#include <vcl.h>
#include <iostream>
#include <fstream>
#include <stdlib.h>
#pragma hdrstop

#include "main.h"
#include "interpreter.h"
#include "compiler.h"
#include "InfoForm.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)


using namespace std;
fstream listfile;

String filename;
String mainfilename;

typedef struct{
  String s1;
  String s2;
}t_replace;

unsigned short int codelength;

typedef struct{
  int startnodenr;
  int endnodenr;
  int relstartnodenr;
  int relendnodenr;
  int statemachine;
  int einsortiert;
  int offsetkorrigieren;
  int filenr;
  String condition;
}t_connection;

typedef struct{
  int einsortiert;
  String name;
  int statemachine;
  int state;
  int filenr;
  int nodenr;
}t_statenode;


int cntstatemachines=0;
String statemachinename[MAX_STATEMACHINES][256];

typedef struct{
  String filename;
  bool included;
}t_incfile;

t_incfile includefiles[100];
int nrincludefiles;

#define STYPS 17
String Styps[STYPS]={"NOTYP","KEYCLICK","KEYPRESSED","KEYRELEASED","KEYRELEASETIME",
                  "KEYDOWN","KEYDOWNTIME","KEYUP",
                  "DINPUTLOW","DINPUTHIGH","DINPUTLH","DINPUTHL","AINPUT",
                  "RELAY","STATE","STATETIME","VARIABLE"};

#define SCOMPTYPS 9
String Scomptyps[9]={"NOTDEFINED","NEVER","ALLWAYS","==","!=",">","<",
                     ">=","<="};



t_connection connection[1000];
int connections=0;

t_statenode StateNodes[1000];
int statenodes=0;
String NoteNodes[1000];
int notenodes=0;
t_replace Replaces[1000];
int replaces=0;

String ErrorString="";

int offset,or_offset,and_offset;
t_actions* paction;
t_or_compares* porcompare;
t_compares* pcompare;
t_codeheader* pcompcodeheader;
unsigned char* pcompcodebytes;

bool run=false;


/**********************************************************
Zustnde der Statemachines mit Defaultwerten fllen
**********************************************************/
void FillStateMachines(void){
int i;
int ii;
  for (i=0;i<MAX_STATEMACHINES;i++)
    for (ii=0;ii<256;ii++)
      statemachinename[i][ii]="StateMachine"+IntToStr(i)+"="+IntToStr(ii);
}


/**********************************************************
Fehlernachricht im Debugfenster und im Listfile ausgeben
s: Fehlermeldung
**********************************************************/
void ErrorMsg(String s){
  ErrorString+=s+"\r\n";
  listfile << " ***" << s.c_str() << "*** ";
}

/**********************************************************
Aus einem String die Zahl extrahieren. Zeichen ignorieren
ps: String, der in eine Zahl gewandelt wird
return: Zahlenwert
**********************************************************/
int myString2Int(String ps){
int i;
String s;
  s=ps;
  if ((s.c_str()[2]<'0') || (s.c_str()[2]>'9'))
     s=s.SubString(1,2);
  if ((s.c_str()[1]<'0') || (s.c_str()[1]>'9'))
     s=s.SubString(1,1);
  return s.ToInt();
}


/**********************************************************
Ein neunes Programm wird geladen. Variablen zurcksetzen
**********************************************************/
void newProgram(void){
int i;
  for (i=0;i<MAX_CODE;i++){
    code[i]=0xFF;
  }
  codelength=0;
  pcompcodeheader=(t_codeheader*)&code[0];
  pcompcodeheader->length=BIGENDIAN(codelength);
  pcompcodeheader->version=1;
  pcompcodebytes=&pcompcodeheader->bytes[0];
  offset=0;
}

/**********************************************************
Neuen Ausdruck in die Replace-Liste mit aufnehmen
s1,s2: s1 wird spter durch s2 ersetzen
**********************************************************/
void AddReplace(String s1,String s2){
 Replaces[replaces].s1=s1;Replaces[replaces].s2=s2;
 replaces++;
}

/**********************************************************
Den String s in der Replace Liste suchen und ggf. ersetzen
s: s in Replace-Liste suchen und durch den entsprechenden
   String ersetzen
return: ersetzer String
**********************************************************/
String Replace(String s){
int i;
int pos;
int loops,rloops;
int maxstrlen;
int strlen;
String rs;
bool replaced;

  rs=s;
  rloops=0;

  //solange ersetzen, bis es nicht mehr zum Ersetzen gibt
  do{
   rloops++;
   replaced=false;

   //zuerst nach dem lngsten String suchen
   maxstrlen=0;
   for (i=0;i<replaces;i++){
     if (Replaces[i].s1.Length()>maxstrlen){
       maxstrlen=Replaces[i].s1.Length();
     }
   }

   //Alle Eintrge durchsuchen und ersetzen. Dabei immer mit den lngsten beginnen
   for (strlen=maxstrlen;strlen>0;strlen--){
    for (i=0;i<replaces;i++){
      if (Replaces[i].s1.Length()==strlen){
        do{
          loops=0;
          pos=rs.Pos(Replaces[i].s1);
          if (pos){
            rs.Delete(pos,Replaces[i].s1.Length());
            rs.Insert(Replaces[i].s2,pos);
            replaced=true;
          }
        } while(pos && (loops<100));
        if (loops>=100)
          ErrorMsg("Fehler beim Textersetzen "+Replaces[i].s1+" durch "+Replaces[i].s2);
      }
    }
   }

  }while (replaced && (rloops<10));

  if (loops>=10)
    ErrorMsg("Rekursives Textersetzen: \""+s+"\"");

  return rs;
}


/**********************************************************
Den Startwert eines Zustandsmaschine setzen
statemachine: Zustandsmaschine wird mit Wert
initstate: initialisiert
**********************************************************/
void SetInitState(unsigned char statemachine,unsigned char initstate){
  pcompcodeheader->initstate[statemachine]=initstate;
  listfile << "STATE" << (int)statemachine << ":" << (int)initstate << endl;
}


/**********************************************************
Ein neunes Kommando in den Bytecode aufnehmen
obj_typ: Art des Objektes, das gesetzt wird
obj_nr: Index des Objektes, das gesetzt wird
val: Wert, auf den das Objekt gesetzt wird
ors: Anzahl der ODER-Bedingungen, die folgen
**********************************************************/
void newCommand(unsigned char obj_typ,unsigned char obj_nr,short int val,unsigned char ors){
  paction=(t_actions*)(pcompcodebytes+offset);
  //Bytecode mit Inhalt fllen
  paction->object.obj_typ=obj_typ;
  paction->object.obj_nr=obj_nr;
  paction->ors=ors;
  paction->val=BIGENDIAN(val);
  offset+=SIZE_ACTION;
  codelength++;
  pcompcodeheader->length=BIGENDIAN(codelength);
  or_offset=0;

  //In Listfile aufnehmen
  listfile << endl;
  if (obj_typ<STYPS)
    listfile << Styps[obj_typ].c_str();
  else
    listfile << (int)obj_typ;
  listfile << (int)obj_nr << "=" << (int)val << ":";
}

/**********************************************************
Eine neue ODER Bedingung aufnehmen
ands: Anzahl der UND-Bedingungen, die folgen
**********************************************************/
void newOr(unsigned char ands){
  porcompare=(t_or_compares*)((unsigned char*)&paction->orcompares[0]+or_offset);
  //Bytecode mit Inhalt fllen
  porcompare->ands=ands;
  offset+=SIZE_OR_COMPARE;
  or_offset+=SIZE_OR_COMPARE;
  and_offset=0;

  //In Listfile aufnehmen
  listfile << ",";
}

/**********************************************************
Eine neue (UND) Bedingung aufnehmen
obj_typ: Art des Objektes, das verglichen wird
obj_nr: Index des Objektes, das verglichen wird
comptyp: Art des Vergleichs
compvalue: Vergleichswert
**********************************************************/
void newCompare(unsigned char obj_typ,unsigned char obj_nr,unsigned char comptyp,short int compvalue){
  pcompare=(t_compares*)((unsigned char*)&porcompare->andcompares[0]+and_offset);
  //Bytecode mit Inhalt fllen
  pcompare->object.obj_typ=obj_typ;
  pcompare->object.obj_nr=obj_nr;
  pcompare->comptyp=comptyp;
  pcompare->compvalue=BIGENDIAN(compvalue);
  offset+=SIZE_COMPARE;
  and_offset+=SIZE_COMPARE;
  or_offset+=SIZE_COMPARE;

  //In Listfile aufnehmen
  listfile << "&";
  if (obj_typ<STYPS)
    listfile << Styps[obj_typ].c_str();
  else
    listfile << (int)obj_typ;
  listfile << (int)obj_nr;
  if (comptyp<SCOMPTYPS)
    listfile << Scomptyps[comptyp].c_str();
  else
    listfile << "?";
  listfile << (int)compvalue;
}


/**********************************************************
Teilstring aus einem String extrahieren.
nr: Nummer des Teilstrings
s: String, der berprft wird
c: Zeichen, das den String in Teilstrings teilt
return: Teilstring
**********************************************************/
String mySubString(int nr,String s,char c){
String s1;
int i1,i2;
int i;
int chars;

  chars=0;
  i1=-1;
  i2=s.Length();
  for (i=0;i<s.Length();i++){
    if (s.c_str()[i]==c){
      chars++;
      if (nr==chars){
        i1=i;
      }
      if ((nr+1)==chars){
        i2=i;
      }
    }
  }
  s1=s.SubString(i1+2,i2-i1-1);
  return s1;
}


/**********************************************************
String nach Anzahl der Vorkommen eines Zeichens durchsuchen
s: String, der berprft wird
return: Anzahl der Vorkommen
**********************************************************/
int countchar(String s,char c){
int i;
int chars;
  chars=0;
  for (i=0;i<s.Length();i++){
    if (s.c_str()[i]==c)
      chars++;
  }
  return chars;
}


/**********************************************************
String nach Anzahl der ODER Verknpfungen durchsuchen
s: String, der berprft wird
return: Anzahl der Vorkommen
**********************************************************/
int calcOrs(String s){
 return countchar(s,',')+1;
}


/**********************************************************
String nach Anzahl der UND Verknpfungen durchsuchen
s: String, der berprft wird
nr: Index der ODER-Verknpfung im String, der analysiert wird
return: Anzahl der Vorkommen
**********************************************************/
int calcAnds(int nr, String s){
 if (s.IsEmpty())
   return 0;
 else
   return countchar(mySubString(nr,s,','),'&')+1;
}


/**********************************************************
Aus einem String den Zahlenwert extrahieren
s: String, der analysiert wird
istime: 1, wenn es sich um eine Zeitangabe handelt
return: extrahierter Zahlenwert
**********************************************************/
int getVal(String s,int istime){
double dval;
int val;
int i;
int posnonr;
String sp;
String rest;

  sp=s;
  val=1;

  //kein String angegeben
  if (s.Length()==0){
    //ErrorMsg("Kein Zahlenwert angegebeben");
    return 1;
  }


  //von rechts im String die Position suchen, ab welcher die Zahl beginnt
  posnonr=s.Length();
  for (i=s.Length()-1;i>=0;i--){
    if (((s.c_str()[i]>='0')&&(s.c_str()[i]<='9'))||(s.c_str()[i]=='.')){
      posnonr=i;
    }
    else{
      i=-1;
    }
  }

  //vor der Zahl wird ein Leerzeichen erwartet
  if (posnonr>0){
    if (s.c_str()[posnonr-1]!=' '){
      ErrorMsg("Vor dem Zahlenwert wird ein Leerzeichen erwartet. "+s);
      return 1;
    }
  }

  // alle Zeichen rechts abschneiden, die nicht zur Zahl gehren
  if (posnonr!=s.Length()){
    rest=s.SubString(1,posnonr);
    s=s.SubString(posnonr+1,s.Length()-posnonr);
  }
  else
    rest=s;

  if (rest.Trim().Length()>0){
      ErrorMsg("Der Teil: \""+rest+"\" in \""+s+"\" kann nicht dekodiert werden");
  }

  // . durch , ersetzen
  for (i=0;i<s.Length();i++){
    if (s.c_str()[i]=='.'){
      s.c_str()[i]=',';
    }
  }

  //Zahl in Integer wandeln
  try{
    dval=s.ToDouble();
    if (istime)
      dval=dval*TIMEBASE;
    val=(int)(dval+0.00001);
  }
  catch (EConvertError *){
    val=1;
    ErrorMsg("Fehler im Zahlenformat bei:\""+sp+"\"");
  };

  return val;
}


/**********************************************************
Aus einem String den Index eines Objektes extrahieren
zB: aus "KEY7 >=12" wird "7" extrahiert
s: String, der analysiert wird
what: 0 returns Nr, 1 returns Pos after Nr.
return: extrahierter Index
**********************************************************/
int getNr(String s,int what){
int i=0;
int pos=0;
int error=0;
String s1,s2;

  //ersten 3 Zeichen sind Objekttyp. Danach min. 1 Zeichen fr Index
  if (s.Length()>=4){

    //ersten 3 Zeichen abschneiden
    s2=s.SubString(4,s.Length()-3);

    //nur Ziffern bernehmen
    s1="   ";
    for (i=0;i<s2.Length();i++){
      if ((s2.c_str()[i]>='0') && (s2.c_str()[i]<='9'))
        s1.c_str()[i]=s2.c_str()[i];
      else
        i=s2.Length();
    }
    s1=s1.Trim();

    //keinen Index gefunden
    if (s1.IsEmpty())
      error=1;
    else {
      //in Zahl wandeln
      try{
        i=s1.ToInt();
        pos=4+s1.Length();
      }
      catch (EConvertError *){
        i=0;
        error=1;
        ErrorMsg("Fehler im Zahlenformat bei:\""+s+"\"");
      };
    }

  }
  else
   error=1;

  if (error)
    ErrorMsg("Bedingung \""+s+"\" bentigt Index, z.B: KEY7");

  if (what==0)
   return i; //Wert zurckliefern
  else
   return pos; //Position nach Wert zurckliefern
}



/**********************************************************
Nach Vorkommen von Teilstringen in einem String suchen.
Nur ganze Wrter bercksichtigen. Gro/Kleinschreibung ignorieren
s: String, der analysiert wird
search: String, der in s gesucht wird
return: Position, ab der der String gefunden wurde
**********************************************************/
int findInStr(String s,String search){
 s=" "+s.UpperCase()+" ";
 search=search.UpperCase();
 if (s.Pos(search))
   return s.Pos(search)-1;
 else
   return 0;
}




/**********************************************************
Eine Bedingung als String dekodieren
s: String, der dekodiert wird
nr: Defaultwert fr Index, falls keiner gefunden wird
**********************************************************/
void decodeCondition(String s , int nr ){
int comp;
int val;
//int valpos=1;
int i;
int istime;
int typ;
int pos=1;
String s1;
String s2;
bool invertiert=false;

  s1=s.Trim();

  //negieren, wenn mit "NOT" begonnen wird
  if (findInStr(s1,"NOT ")==1){
    invertiert=true;
    s1=s1.SubString(5,s1.Length()-4).Trim();
  }

  //Leerstring ist immer wahr
  if (s1.IsEmpty()){
    if (!invertiert)
      newCompare(NOTYP,0,ALLWAYS,0);
    else
      newCompare(NOTYP,0,NEVER,0);
     return;
  }

  //Defaultwerte
  typ=STATE;
  comp=COMPNOTDEFINED;
  val=1;

  //Ist es ein KEY-Objekt ?
  if (s1.Pos("KEY")==1){
    typ=KEYCLICK;
    nr=getNr(s1,0);
    pos=getNr(s1,1);
  }

  //Ist es ein DIN-Objekt ?
  if (s1.Pos("DIN")==1){
    typ=DINPUTHIGH;
    nr=getNr(s1,0);
    pos=getNr(s1,1);
  }

  //Ist es ein AIN-Objekt ?
  if (s1.Pos("AIN")==1){
    typ=AINPUT;
    nr=getNr(s1,0);
    pos=getNr(s1,1);
  }

  //Ist es ein STA-Objekt ?
  if (s1.Pos("STA")==1){
    typ=STATE;
    nr=getNr(s1,0);
    pos=getNr(s1,1);
  }

  //Ist es ein REL-Objekt ?
  if (s1.Pos("REL")==1){
    typ=RELAY;
    nr=getNr(s1,0);
    pos=getNr(s1,1);
  }

  //Objekttyp und Nummer ggf. abschneiden
  s1=s1.SubString(pos,s1.Length()-pos+1);


  //zustzliche Attribute
  if ((typ==KEYCLICK)&&(pos=findInStr(s1,"PRESSED"))){
    s1=s1.Delete(pos,7);
    typ=KEYPRESSED;
  }
  if ((typ==KEYCLICK)&&(pos=findInStr(s1,"RELEASED"))){
    s1=s1.Delete(pos,8);
    typ=KEYRELEASED;
  }
  if ((typ==KEYCLICK)&&(pos=findInStr(s1,"DOWN"))){
    s1=s1.Delete(pos,4);
    typ=KEYDOWN;
  }
  if ((typ==KEYCLICK)&&(pos=findInStr(s1,"UP"))){
    s1=s1.Delete(pos,2);
    typ=KEYUP;
  }

  if ((typ==DINPUTHIGH)&&(pos=findInStr(s1,"LOW"))){
    s1=s1.Delete(pos,3);
    typ=DINPUTLOW;
  }
  if ((typ==DINPUTHIGH)&&(pos=findInStr(s1,"LH"))){
    s1=s1.Delete(pos,2);
    typ=DINPUTLH;
  }
  if ((typ==DINPUTHIGH)&&(pos=findInStr(s1,"HL"))){
    s1=s1.Delete(pos,2);
    typ=DINPUTHL;
    val=0;
  }



  //Vergleichsoperator suchen
  if (i=s1.Pos("==")){
    if (!invertiert)
      comp=EQUAL;
    else
      comp=UNEQUAL;
    s1=s1.Delete(i,2);
  }
  if (i=s1.Pos("<>")){
    if (!invertiert)
      comp=UNEQUAL;
    else
      comp=EQUAL;
    s1=s1.Delete(i,2);
  }
  if (i=s1.Pos("!=")){
    if (!invertiert)
      comp=UNEQUAL;
    else
      comp=EQUAL;
    s1=s1.Delete(i,2);
  }
  if (i=s1.Pos(">=")){
    if (!invertiert)
      comp=EQUAL_OR_GREATER;
    else
      comp=SMALLER;
    s1=s1.Delete(i,2);
  }
  if (i=s1.Pos("<=")){
    if (!invertiert)
      comp=EQUAL_OR_SMALLER;
    else
      comp=GREATER;
    s1=s1.Delete(i,2);
  }
  if (i=s1.Pos(">")){
    if (!invertiert)
      comp=GREATER;
    else
      comp=EQUAL_OR_SMALLER;
    s1=s1.Delete(i,1);
  }
  if (i=s1.Pos("<")){
    if (!invertiert)
      comp=SMALLER;
    else
      comp=EQUAL_OR_GREATER;
    s1=s1.Delete(i,1);
  }
  if (i=s1.Pos("=")){
    if (!invertiert)
      comp=EQUAL;
    else
      comp=UNEQUAL;
    s1=s1.Delete(i,1);
  }

  //Teilstring nach Vergleichsoperator analysieren
  //s2=s1.SubString(valpos,s1.Length()-valpos+1).Trim();
  s2=s1.Trim();

  //endet der String auf "s" fr "Sekunde" handelt es sich um eine Zeitangabe
  istime=0;
  if (s2.Length()>=2){
    if ((s2.c_str()[s2.Length()-1]=='s') &&
        (s2.c_str()[s2.Length()-2]>='0') &&
        (s2.c_str()[s2.Length()-2]<='9')){
      istime=1;
      s2=s2.SubString(1,s2.Length()-1);

      //bei Zeitangaben werden manche Objekte zu Zeitobjekte
      if (typ==KEYCLICK)
        typ=KEYDOWNTIME;
      if (typ==KEYPRESSED)
        typ=KEYDOWNTIME;
      if (typ==KEYDOWN)
        typ=KEYDOWNTIME;

      if (typ==KEYRELEASED)
        typ=KEYRELEASETIME;

      if (typ==STATE)
        typ=STATETIME;

      //Zeiten werden standardmig mit >= verglichen
      if (comp==COMPNOTDEFINED){
        if (!invertiert)
          comp=EQUAL_OR_GREATER;
        else
          comp=SMALLER;
      }

    }
  }

  //Zahlenwert extrahieren
  val=getVal(s2,istime);

  //Defaultwert
  if (comp==COMPNOTDEFINED){
    if (!invertiert)
      comp=EQUAL;
    else
      comp=UNEQUAL;
  }


  //Ergebnis zum Bytecode hinzufgen
  newCompare(typ,nr,comp,val);
}



/**********************************************************
Aus dem Befehls-String eine einzelne Bedingung extrahieren
ornr: Nummer des ODER-Bedingung
andnr: Nummer des UND-Bedingung im ODER-Bedingung
s: String, der analysiert wird
return: einzelne Bedingung
**********************************************************/
String ExtractConditionString(int ornr,int andnr, String s){
String s1;
String s2;
  s1=mySubString(ornr,s,',');
  s2=mySubString(andnr,s1,'&');

  return s2;
}



/**********************************************************
Alle Statenodes durchsuchen und den Index des Statenodes
zurckliefern bei dem filenr und nodenr bereinstimmen
nodenr: NoteNr, die berprft wird
filenr: FileNr, die berprft wird
return: index des Statenodes
**********************************************************/
int getStateNodeIndex(int nodenr, int filenr){
int i;
  for (i=0;i<statenodes;i++){
    if ( (StateNodes[i].nodenr==nodenr) && (StateNodes[i].filenr==filenr) )
      return i;
  }
  ErrorMsg("StateNode nicht gefunden.");
  return 0;
}

/**********************************************************
In den Speicher eingelesenen Zustnde(statenode) und
Notizen(notenodes) in Bytecode bersetzen
**********************************************************/
void compile(void){
int i,ii,iii,ix;
int found,startfound;
int comp_statemachines;
int comp_state;
int reloffset;
int nodenr;
int ands,ors;
String s1,s2,s3,s4;
int rels;



  // DEF Notes suchen
  for (i=0;i<notenodes;i++){
    s1=NoteNodes[i];
    if (s1.Pos(":")>1){
      if (s1.Pos("DEF ")==1){
        s2=s1.SubString(5,s1.Length()-4);
        s3=mySubString(0,s2,':').Trim();
        s4=mySubString(1,s2,':').Trim();
        AddReplace(s3,s4);
      }
    }
  }

  // Suchen nach INITNODE
  comp_statemachines=-1;
  do{
    comp_state=0;
    startfound=0;
    // Startknoten suchen
    for (i=0;i<connections;i++){
      connection[i].offsetkorrigieren=0;
      if ((connection[i].startnodenr==INITNODE) && (!connection[i].einsortiert)){
        startfound=1;
        comp_statemachines++;
        connection[i].statemachine=comp_statemachines;
        StateNodes[getStateNodeIndex(connection[i].endnodenr,connection[i].filenr)].einsortiert=1;
        comp_state++;
        connection[i].offsetkorrigieren=1;
        i=connections;
      }
    }

    if(startfound){
      // Alle Knoten (StateNodes) die an der gleichen Statemachine wie der gefundenen
      // Startknoten hngen suchen und die Statemachine zuordnen
      do{
        found=0;
        for (i=0;i<connections;i++){
          for (ii=0;ii<statenodes;ii++){
            if ((StateNodes[ii].einsortiert) && (StateNodes[ii].filenr==connection[i].filenr) ){
              if (!connection[i].einsortiert){
                if ((connection[i].startnodenr==StateNodes[ii].nodenr) ||
                    (connection[i].endnodenr==StateNodes[ii].nodenr)){
                  found=1;
                  connection[i].statemachine=comp_statemachines;
                  connection[i].einsortiert=1;
                  connection[i].offsetkorrigieren=1;
                  if (connection[i].startnodenr>=0){
                    ix=getStateNodeIndex(connection[i].startnodenr,connection[i].filenr);
                    StateNodes[ix].einsortiert=1;
                    StateNodes[ix].statemachine=comp_statemachines;
                  }
                  if (connection[i].endnodenr>=0){
                    ix=getStateNodeIndex(connection[i].endnodenr,connection[i].filenr);
                    StateNodes[ix].einsortiert=1;
                    StateNodes[ix].statemachine=comp_statemachines;
                  }
                  i=connections;
                  ii=statenodes;
                }
              }
            }
          }
        }
      } while (found);
    }
    else{
      for (i=0;i<connections;i++){
        if(!connection[i].einsortiert){
          ErrorMsg("Es wurden Zustandsautomaten gefunden, die nicht ber einen Startpunkt verfgen.");
          i=connections;
        }
      }
    }

    //kleinsten nodenr in aktueller Statemachine suchen.
    reloffset=999;
    for (i=0;i<connections;i++){
      if (connection[i].offsetkorrigieren){
        if (connection[i].endnodenr>=0){
          if (connection[i].endnodenr<reloffset)
            reloffset=connection[i].endnodenr;
        }
        if (connection[i].startnodenr>=0){
          if (connection[i].startnodenr<reloffset)
            reloffset=connection[i].startnodenr;
        }
      };
    }

    //und alle Notes um diesen Wert korrigieren
    for (i=0;i<connections;i++){
      if (connection[i].offsetkorrigieren){

        if (connection[i].startnodenr>=0){
          if (connection[i].startnodenr>=reloffset){
             connection[i].relstartnodenr=connection[i].startnodenr-reloffset;
             ix=getStateNodeIndex(connection[i].startnodenr,connection[i].filenr);
             StateNodes[ix].state=connection[i].relstartnodenr;
          }
        }

        if (connection[i].endnodenr>=0){
          if (connection[i].endnodenr>=reloffset){
             connection[i].relendnodenr=connection[i].endnodenr-reloffset;
             ix=getStateNodeIndex(connection[i].endnodenr,connection[i].filenr);
             StateNodes[ix].state=connection[i].relendnodenr;
          }
        }

        connection[i].offsetkorrigieren=0;
      }
    }

  } while (startfound);




  //Die Bezeichnungen der einzelnen Zustnde in die Replace Liste mit aufnehmen
  for (i=0;i<statenodes;i++){
    if (StateNodes[i].name.Length()<3)
      ErrorMsg("Zustnde mssen mit einem mindestens 3 Zeichen langen Namen versehen werden: "+StateNodes[i].name);
    else
      if ((StateNodes[i].name.c_str()[0]>='0') && (StateNodes[i].name.c_str()[0]<='9'))
        ErrorMsg("Des Name eines Zustandes darf nicht mit einer Zahl beginnen: "+StateNodes[i].name);
      else{
        statemachinename[StateNodes[i].statemachine][StateNodes[i].state]=StateNodes[i].name;
        AddReplace(StateNodes[i].name,"STA"+IntToStr(StateNodes[i].statemachine)+"="+IntToStr(StateNodes[i].state));
      }
  }


  //Replaceliste in Listfile ausgeben
  listfile << endl << "Definitions:" << endl;
  for (i=0;i<replaces;i++){
    listfile << "DEF " << Replaces[i].s1.c_str() << ":" << Replaces[i].s2.c_str()<< endl;
  }


  // Initialisierungswerte des Zustandsmaschinen in Listfile ausgeben
  listfile << endl << "Init States:" << endl;
  // Init States suchen
  for (i=0;i<connections;i++){
    if (connection[i].startnodenr==INITNODE){
      SetInitState(connection[i].statemachine,connection[i].relendnodenr);
    }
  }

  //Alle Kommandos mit Bedingungen in dekodieren und in Listfile ausgeben
  listfile << endl << "Conditions:" ;
  // Bedinungen dekodieren
  for (i=0;i<connections;i++){
    if (connection[i].startnodenr!=INITNODE){
      connection[i].condition=Replace(connection[i].condition);
      ors=calcOrs(connection[i].condition);
      newCommand(STATE,connection[i].statemachine,connection[i].relendnodenr,ors);
      for (ii=0;ii<ors;ii++){
        ands=calcAnds(ii,connection[i].condition);
        newOr(ands+1);
        newCompare(STATE,connection[i].statemachine,EQUAL,connection[i].relstartnodenr);
        for (iii=0;iii<ands;iii++){
          s1=ExtractConditionString(ii,iii,connection[i].condition);
          decodeCondition(s1,connection[i].statemachine);
        }
      }
    }
  }


  // Relay Notes suchen, dekodieren und in Listfile aufnehmen
  listfile << endl << endl<< "Relay Outputs:";
  rels=0;
  for (i=0;i<notenodes;i++){
    s1=Replace(NoteNodes[i]);
    if (s1.Pos(":")>1){
      if (s1.Pos("REL")==1){
        s2=s1.SubString(s1.Pos(":")+1,s1.Length()-s1.Pos(":"));
        s2=Replace(s2);
        ors=calcOrs(s2);
        rels++;
        newCommand(RELAY,getNr(s1,0),1,ors);
        for (ii=0;ii<ors;ii++){
          ands=calcAnds(ii,s2);
          newOr(ands);
          for (iii=0;iii<ands;iii++){
            s3=ExtractConditionString(ii,iii,s2);
            decodeCondition(s3,0);
          }
        }
      }
      else if (s1.Pos("DEF ")==1){
       //... wurde bereits eingelesen
      }
      else{
        ErrorMsg("Notiz \""+s1+"\" enthlt ein Doppelpunkt, beginnt jedoch nicht mit REL oder DEF.");
      }
    }
  }
  if (!rels)
        ErrorMsg("Keine Relais Ausgnge im Format REL01:WISCHER_AUS definiert.");


  //Anzahl der Zustandsmaschinen in Code aufnehmen
  cntstatemachines=comp_statemachines+1;
  pcompcodeheader->statemachines=cntstatemachines;
  strcpy(pcompcodeheader->filename,mainfilename.SubString(1,63).c_str());
  strcpy(pcompcodeheader->datestring,DateTimeToStr(Now()).SubString(1,31).c_str());




  if (ErrorString.IsEmpty()){
     Form1->ErrorMemo->Text="ok ! - ("+IntToStr(3+MAX_STATEMACHINES+offset)+" Bytes)";
  }
  else
     Form1->ErrorMemo->Text=ErrorString;
  listfile.close();
}



/**********************************************************
Prft in der Liste includefiles, ob es noch Files zum
Einbinden gibt
return: TRUE, wenn es noch Files gibt
**********************************************************/
bool thereAreMoreFilesToInclude(void){
int i;

  for (i=1;i<nrincludefiles;i++)
    if (!includefiles[i].included){
      filename=includefiles[i].filename;
      includefiles[i].included=true;
      return true;
    }
  return false;
}



/**********************************************************
Prft Dateiname in der Liste includefiles vorhanden ist
return: TRUE, wenn es vorhanden ist
**********************************************************/
bool isInIncFileList(String s){
int i;
bool found=false;

  for (i=0;i<nrincludefiles;i++)
    if (includefiles[nrincludefiles].filename.Pos(s))
      found=true;

  return found;
}



/**********************************************************
Fgt Dateinamen zur Liste der include Files hinzu
s: Dateiname
**********************************************************/
void AddIncFile(String s){
int i;
int pcfound;

  //keine Unterscheidung Gro/Kleinschreibung
  s=s.LowerCase();

  //alle Slashs durch Backslashes ersetzen
  for (i=0;i<s.Length();i++){
    if (s.c_str()[i]=='/')
      s.c_str()[i]='\\';
  }

  // alle %20 durch Leerzeichen ersetzen
  while(pcfound=s.Pos("%20")){
    s.Delete(pcfound,3);
    s.Insert(" ",pcfound);
  }

  //Dateinamen zur Liste hinzufgen, wenn er nicht schon vorhanden ist
  if (!isInIncFileList(s)){
    includefiles[nrincludefiles].filename=s;
    includefiles[nrincludefiles].included=false;
    if (nrincludefiles<50){
      nrincludefiles++;
      //nchsten Eintrag lschen
      includefiles[nrincludefiles].filename="empty";
      includefiles[nrincludefiles].included=false;
    }
    else
      ErrorMsg("Rekursives Einbinden von Dateien.");
  }
}


/**********************************************************
Violet XML File einlesen
**********************************************************/
void LoadVioletFile(void){
String dispfilename;
String zeile;
char czeile[1000];
enum{
     DONOTHING,
     ADDNODE,
     CONNECT
} method;
enum{
     NOTHING,
     STATENODE,
     NOTENODE,
     DIAGRAMLINK
} nodetype;
int localstatenodenr=0;
int statenodenr=-1;
int nodenodenr=-1;
int connectionnr=-1;
int i;
int filenr;
int zeilennr;
bool stringstartfound,stringendfound;
bool filefound;


  //Replace Liste leeren und mit Systemwerten setzen
  replaces=0;
  AddReplace("&gt;",">");
  AddReplace("&lt;","<");
  AddReplace("&amp;","&");

  newProgram();

  //Interpreter stoppen
  run=false;

  Form1->Caption="StateMachine";
  Form1->ListStates->Items->Clear();

  //FileOpen Dialog benutzen
  Form1->OpenDialog1->Filter="*.state.violet|*.state.violet";
  if (Form1->OpenDialog1->Execute()){
    filename = Form1->OpenDialog1->FileName;

    dispfilename=filename;
    if (dispfilename.Length()>53)
      dispfilename="..."+dispfilename.SubString(dispfilename.Length()-49,50);
    mainfilename=dispfilename;
    Form1->Caption="StateMachine - "+dispfilename;

    ErrorString="";

    //Listfile ffnen
    listfile.open("compile.lst",ios::out);
    listfile << "Files:" <<endl;

    //Liste Includefiles zurcksetzen
    nrincludefiles=0;
    includefiles[0].filename="empty";
    includefiles[0].included=false;

    AddIncFile(filename);

    fstream violetfile;
    filenr=0;

    //alle Files ffnen, die in den VioletFiles referenziert werden
    do{
      method=DONOTHING;
      nodetype=NOTHING;
      stringstartfound=false;
      stringendfound=false;
      filenr++;
      violetfile.open(filename.c_str());
      if (!violetfile.is_open())
        ErrorMsg("Datei: \""+filename+"\" nicht gefunden");
      zeilennr=0;
      listfile << filename.c_str() <<endl;

      //einzelnes VioletFile ffnen
      while(!violetfile.eof() && violetfile.is_open()){
        violetfile.getline(czeile,1000);
        zeilennr++;
        zeile=czeile;
        zeile=zeile.Trim();

        //nach neuen Knoten suchen
        if (zeile.Pos("<void method=\"addNode\">"))
           method=ADDNODE;

        //nach neuen Verbindungen suchen
        if (zeile.Pos("<void method=\"connect\">")){
           method=CONNECT;
           connectionnr++;
           connection[connectionnr].condition="";
           connection[connectionnr].startnodenr=NOTDEFINED;
           connection[connectionnr].endnodenr=NOTDEFINED;
           connection[connectionnr].statemachine=NOTDEFINED;
           connection[connectionnr].filenr=filenr;
           connection[connectionnr].einsortiert=0;

        }

        if (method==ADDNODE){

          // Knotentyp 1: Zustand einer Zustandsmaschine
          if (zeile.Pos("class=\"com.horstmann.violet.StateNode\"")){
            nodetype=STATENODE;
            localstatenodenr=myString2Int(zeile.SubString(22,3));
            statenodenr++;
          }

          // Knotentyp 2: Notiz
          if (zeile.Pos("class=\"com.horstmann.violet.NoteNode\"")){
            nodetype=NOTENODE;
          }

          // Knotentyp 3: Diagramlink
          if (zeile.Pos("class=\"com.horstmann.violet.framework.diagram.DiagramLink\"")){
            nodetype=DIAGRAMLINK;
          }


          //Im Knotentyp Zustand den Namen des Zustands suchen
          if (nodetype==STATENODE){
            if (zeile.Pos("<string>")){
              if (zeile.Pos("</string>"))
                zeile=zeile.SubString(9,zeile.Length()-17);
              else
                zeile=zeile.SubString(9,zeile.Length()-8);
              StateNodes[statenodenr].name=zeile;
              StateNodes[statenodenr].einsortiert=0;
              StateNodes[statenodenr].filenr=filenr;
              StateNodes[statenodenr].nodenr=localstatenodenr;
              statenodes=statenodenr+1;
            }
          }

          //Im Knotentyp Notiz, alle Zeilen aufnehmen
          if (nodetype==NOTENODE){
            if (zeile.Pos("<string>")){
              stringstartfound=true;
              zeile=zeile.SubString(9,zeile.Length()-8);
            }

            if (zeile.Pos("</string>")){
              zeile=zeile.SubString(1,zeile.Length()-9);
              stringendfound=false;
            }

            if (stringstartfound){
              nodenodenr++;
              NoteNodes[nodenodenr]=zeile;
              notenodes=nodenodenr+1;
            }

            if (stringendfound){
                stringstartfound=false;
                stringendfound=false;
            }
          }

          //Im Knotentyp Diagramlink den Dateinamen aufnehmen
          if (nodetype==DIAGRAMLINK){
            if (zeile.Pos("<string>/")){
              zeile=zeile.SubString(10,zeile.Length()-18);
              AddIncFile(zeile);
            }
          }



        }


        //Verbindungen analysieren
        if (method==CONNECT){

          //Verbindung Note connector ist nicht erlaubt
          if (zeile.Pos("class=\"com.horstmann.violet.NoteEdge\"")){
            ErrorMsg("Verbindungen mit \"Note connectors\" drfen nicht verwendet werden.");
          }

          // Bedingung an der Verbindung suchen
          if (zeile.Pos("<string>")){
            zeile=zeile.SubString(9,zeile.Length()-17);
            connection[connectionnr].condition=Replace(zeile);
          }

          // Start und Endzustand der Verbindung suchen
          if (zeile.Pos("<object idref=\"StateNode")){
            if (connection[connectionnr].startnodenr==NOTDEFINED){
              connection[connectionnr].startnodenr=myString2Int(zeile.SubString(25,3));
            }
           else if (connection[connectionnr].endnodenr==NOTDEFINED){
              connection[connectionnr].endnodenr=myString2Int(zeile.SubString(25,3));
              connections=connectionnr+1;
            }
          }

          // Initialisierungsknoten suchen
          if (zeile.Pos("<object idref=\"CircularInitialStateNode")){
            if (connection[connectionnr].startnodenr==NOTDEFINED){
              connection[connectionnr].startnodenr=INITNODE;
            }
            else if (connection[connectionnr].endnodenr==NOTDEFINED){
              connection[connectionnr].endnodenr=INITNODE;
              connections=connectionnr+1;
            }
          }

          if (zeile.Pos("<object idref=\"CircularFinalStateNode")){
            ErrorMsg("Ein \"Scenario end\" Punkt darf nicht verwendet werden.");
          }

       }
     }
    violetfile.close();
    }while(thereAreMoreFilesToInclude());


    //eingelesene Knoten und bergnge bersetzen
    compile();

    //Interpreter initialisieren
    InitInterpreter();

    //Interpreter starten, falls fehlerfrei
    if (ErrorString.IsEmpty())
     run=true;

  }

}


